<template>
  <div style="background: #F8F8F8">
    <add-link-dialog :key="dialogLinkKey" v-model="dialogAddLink" @accept="postLink" />
    <add-document-dialog :key="dialogDocumentKey" v-model="dialogAddDocument" :id-appointment-detail="this.detailAppointment.idAppointmentDetail" @refresh="getAppointmentDetails()" />
    <alert-action :key="dialogAlertKey" v-model="dialogAlert" :id-appointment="this.$route.params.id" message="¿Está seguro que desea cancelar la cita?" @refresh="getAppointmentDetails()" />
    <div>
        <v-container>
          <div class="text-h3 mb-5">
            {{ title }}
          </div>
        </v-container>
        <v-container>
          <div class="d-flex justify-space-between">
            <div class="text-h5">Información de la cita</div>
            <div class="d-flex align-center">
              <div class="mr-2">Estado:</div>
              <v-chip
                v-if="detailAppointment.appointment"
                :color="this.getColorChip(detailAppointment.appointment.state)"
                depressed
                text-color="white"
                class="font-weight-bold"
              >
                {{ getNameState(detailAppointment.appointment.state) }}
              </v-chip>
            </div>
          </div>

        </v-container>
        <details-card>
          <div class="d-flex justify-space-between px-5 mb-5">
            <v-card-title v-if="detailAppointment.appointment" class="pa-0">
              {{ formatDate(detailAppointment.appointment.startTime) }}
            </v-card-title>
             <v-btn
                  v-if="detailAppointment.appointment"
                  depressed
                  large
                  rounded
                  color="primary"
                  style="padding:15px"
                  :disabled="!availabilityVideocalling(detailAppointment.appointment.startTime, detailAppointment.appointment.endTime, detailAppointment.appointment.state)"
                  @click="joinVideocall"
                >
                  UNIRSE A LA LLAMADA
                </v-btn>
          </div>
          <div class="d-flex justify-space-between px-5">
              <v-card-title v-if="detailAppointment.appointment" class="pa-0">
                {{ formatHour(detailAppointment.appointment.startTime, detailAppointment.appointment.endTime) }}
              </v-card-title>
                <v-btn
                  v-if="detailAppointment.appointment"
                  depressed
                  large
                  rounded
                  color="primary"
                  style="padding:15px"
                  :disabled="disabledAppointment(detailAppointment.appointment.isCancellable, detailAppointment.appointment.state)"
                  @click="cancelAppointment"
                >
                  CANCELAR CITA
                </v-btn>
          </div>
        </details-card>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">
                Recursos de la cita
              </div>
            </v-col>
          </v-row>
        </v-container>
        <v-container v-if="!loading">
          <v-tabs
            color="primary"
          >
            <v-tab v-if="detailAppointment.appointment">
              {{ 'Enlaces '+ '(' + detailAppointment.specialistResources.linkResources.length + ')' }}
            </v-tab>
            <v-tab v-if="detailAppointment.appointment">
              {{ 'Documentos '+ '(' + detailAppointment.specialistResources.documentResources.length + ')' }}
            </v-tab>

            <v-tab-item
              v-for="n in 2"
              :key="n"
            >
              <details-card v-if="detailAppointment.appointment">
                <v-col v-if="n==1">
                  <div v-if="detailAppointment.specialistResources.linkResources.length > 0">
                    <div v-for="(resource, index) in detailAppointment.specialistResources.linkResources" :key="index">
                      <v-row>
                        <v-col md="3">
                          <v-card-title>{{ resource.name + ":" }}</v-card-title>
                        </v-col>
                        <v-col md="8">
                          <v-text-field
                            outlined
                            :value="resource.url"
                            readonly
                          >
                            <template #append>
                              <a :href="resource.url" target="_blank">
                                <v-icon>
                                  mdi-open-in-new
                                </v-icon>
                              </a>
                            </template>
                          </v-text-field>
                        </v-col>
                      </v-row>
                    </div>
                  </div>
                  <div v-else>
                    <v-card-title> No hay enlaces registrados </v-card-title>
                  </div>
                  <v-row>
                    <v-col md="10" />
                    <v-col md="2">
                      <v-btn
                        depressed
                        large
                        rounded
                        color="primary"
                        style="padding:15px"
                        outlined
                        @click="addLinkInDetail"
                      >
                        Agregar
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-col>
                <v-col v-else>
                  <div v-if="detailAppointment.specialistResources.documentResources.length > 0">
                    <div v-for="(resource, index) in detailAppointment.specialistResources.documentResources" :key="index">
                      <v-row>
                        <v-col md="11">
                          <v-text-field
                            outlined
                            :value="resource.name"
                            readonly
                          >
                            <template #append>
                              <a :href="resource.url" target="_blank">
                                <v-icon color="primary">
                                  mdi-cloud-download
                                </v-icon>
                              </a>
                              <v-icon>mdi-delete</v-icon>
                            </template>
                          </v-text-field>
                        </v-col>
                      </v-row>
                    </div>
                  </div>
                  <div v-else>
                    <v-card-title> No hay documentos registrados </v-card-title>
                  </div>
                  <v-row>
                    <v-col md="10" />
                    <v-col md="2">
                      <v-btn
                        depressed
                        large
                        rounded
                        color="primary"
                        style="padding:15px"
                        outlined
                        @click="addDocumentInDetail"
                      >
                        Agregar
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-col>
              </details-card>
            </v-tab-item>
          </v-tabs>
        </v-container>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">
                Recursos registrados por el paciente
              </div>
            </v-col>
          </v-row>
        </v-container>
        <v-container>
          <v-tabs
            color="primary"
          >
            <v-tab>Cuestionario inicial</v-tab>
            <v-tab v-if="detailAppointment.appointment">
              {{ 'Documentos '+ '(' + detailAppointment.patientResources.documentResources.length + ')' }}
            </v-tab>
            <v-tab-item
              v-for="n in 2"
              :key="n"
            >
              <details-card v-if="detailAppointment.appointment">
                <v-col v-if="n==1">
                  <div>
                    <div class="font-weight-black" style="margin-bottom: 10px; margin-top: 10px">
                      MOTIVO DE LA CITA
                    </div>
                    <v-row v-if="detailAppointment.prePoolDTO.reason === 'Otros'">
                      <details-card
                        v-if="detailAppointment.prePoolDTO.anotherReason"
                      >
                        {{ detailAppointment.prePoolDTO.anotherReason }}
                      </details-card>
                      <details-card
                        v-else>
                        El paciente no registró la razón por la que registró la cita
                      </details-card>
                    </v-row>
                    <v-row v-else>
                      <details-card>
                        {{ detailAppointment.prePoolDTO.descriptionReason }}
                      </details-card>
                    </v-row>
                    <div class="font-weight-black" style="margin-bottom: 10px; margin-top: 10px">
                      INFORMACIÓN ADICIONAL DEL PACIENTE
                    </div>
                    <v-row v-if="detailAppointment.prePoolDTO.additionalInfo">
                      <details-card>
                        {{ detailAppointment.prePoolDTO.additionalInfo }}
                      </details-card>
                    </v-row>
                    <v-row v-else>
                      <details-card>
                        El paciente no registró información adicional
                      </details-card>
                    </v-row>
                  </div>
                </v-col>
                <v-col v-else>
                  <div v-for="(resource, index) in detailAppointment.patientResources.documentResources" :key="index">
                    <v-row>
                      <v-col md="11">
                        <v-text-field
                          outlined
                          :value="resource.name"
                          readonly
                        >
                          <template #append>
                            <a :href="resource.url" target="_blank">
                              <v-icon color="primary">
                                mdi-cloud-download
                              </v-icon>
                            </a>
                            <v-icon>mdi-delete</v-icon>
                          </template>
                        </v-text-field>
                      </v-col>
                    </v-row>
                  </div>
                </v-col>
              </details-card>
            </v-tab-item>
          </v-tabs>
        </v-container>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">
                Información del paciente
              </div>
            </v-col>
          </v-row>
        </v-container>
        <details-card>
          <v-row class="v-container-info-patient">
            <v-col md="2" align="center">
              <img
                v-if="detailAppointment.appointment"
                :src="patientPhoto"
                width="100"
                height="100"
                class="pa-0 secondary rounded-circle d-inline-block"
                alt="Foto del paciente"
              >
            </v-col>
            <v-col md="6">
              <h2 v-if="detailAppointment.appointment" class="font-weight-black">
                {{ detailAppointment.appointment.patient.name + ' ' + detailAppointment.appointment.patient.fatherLastname + ' ' + detailAppointment.appointment.patient.motherLastname }}
              </h2>
              <h3 v-if="detailAppointment.appointment" class="font-weight-regular">
                DNI: {{ detailAppointment.appointment.patient.dni }}
              </h3>
              <h3 v-if="detailAppointment.appointment" class="font-weight-regular">
                Número de celular: {{ detailAppointment.appointment.patient.phoneNumber }}
              </h3>
              <h3 v-if="detailAppointment.appointment" class="font-weight-regular">
                Correo electrónico:    {{ detailAppointment.appointment.patient.email }}
              </h3>
            </v-col>
            <v-col md="4">
              <v-btn
                depressed
                large
                rounded
                color="primary"
                style="padding:15px"
                @click="goToRecord(detailAppointment.appointment.patient.dni)"
              >
                VER HISTORIAL DE CITAS
              </v-btn>
            </v-col>
          </v-row>
        </details-card>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">
                Anotaciones de la cita
              </div>
            </v-col>
          </v-row>
        </v-container>
        <details-card>
          <v-container>
            <v-row>
              <v-col md="6">
                <div class="text-h6">
                  Anotaciones de la cita registradas durante la viodellamada:
                </div>
              </v-col>
            </v-row>
          </v-container>
          <v-container>
            <v-row style="padding-right: 35px">
              <v-col>
                <details-card>
                  <p
                    v-if="detailAppointment.annotations"
                    :style="{ minHeight: height + 'px', borderColor }"
                  >
                    {{ this.detailAppointment.annotations }}
                  </p>
                  <p
                    v-else
                    :style="{ minHeight: height + 'px', borderColor }"
                  >
                    No se ha realizado anotaciones de la sesión
                  </p>
                </details-card>
              </v-col>
            </v-row>
          </v-container>
        </details-card>
        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">
                Resultados de la cita
              </div>
            </v-col>
          </v-row>
        </v-container>
        <details-card>
          <v-container>
            <v-row>
              <v-col md="6">
                <div class="text-h6">
                  Registre la información del resultado de la cita para el paciente:
                </div>
              </v-col>
            </v-row>
          </v-container>
          <v-container>
            <v-row style="padding-right: 35px">
              <v-col>
                <toolbar :buttons-display="buttonsDisplay" />
                <div
                  v-if="detailAppointment.results"
                  id="RTE__edition__field"
                  contenteditable="true"
                  :style="{ minHeight: height + 'px', borderColor }"
                  @input="onUpdate"
                  v-html="this.detailAppointment.results.substring(1).slice(0,-1)"
                />
                <div
                  v-else
                  id="RTE__edition__field2"
                  contenteditable="true"
                  :style="{ minHeight: height + 'px', borderColor }"
                  @input="onUpdate"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col md="4" lg="2">
                <v-btn
                  depressed
                  large
                  rounded
                  color="primary"
                  style="padding:15px"
                  @click="save"
                >
                  GUARDAR RESULTADOS
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
          <v-container>
            <v-row>
              <v-col md="6">
                <div class="text-h6">
                  Transcripción de la sesión
                </div>
              </v-col>
            </v-row>
            <v-row>
              <v-col md="4" lg="2">
                <v-btn
                  depressed
                  large
                  rounded
                  color="primary"
                  style="padding:15px"
                  to="transcripcion"
                  append
                >
                  VER TRANSCRIPCIÓN
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </details-card>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';
import { formatAMPM } from "~/helpers/time";
import moment from 'moment-timezone';
import DetailsCard from '~/components/Cards/DetailsCard.vue';
import AddLinkDialog from '~/components/Dialogs/AddLinkDialog';
import AddDocumentDialog from '~/components/Dialogs/AddDocumentDialog';
import Toolbar from '~/components/Toolbar/Toolbar.vue';
import AlertAction from '~/components/Alert/AlertAction';

export default {
  name: 'DetailSessionPatient',
  components: {
    'details-card': DetailsCard,
    'add-link-dialog': AddLinkDialog,
    'add-document-dialog': AddDocumentDialog,
    'toolbar': Toolbar,
    'alert-action': AlertAction,
  },
  props: {
    borderColor: {
      type: String,
      required: false,
      default: 'rgba(0, 0, 0, 0.5)',
    },
    buttonsDisplay: {
      type: Object,
      required: false,
    },
    value: {
      type: String,
      required: false,
      default: '',
    },
    height: {
      type: Number,
      required: false,
      default: 200,
    },
  },
  data() {
    return {
      renderDocuments: 100,
      isCancelable: false,
      accessVideocallingValue: false,
      stateSession: '2',
      dialogLinkKey: 0,
      dialogDocumentKey: 10,
      dialogAlertKey: 50,
      dialogAddLink: false,
      dialogAddDocument: false,
      dialogAlert: false,
      title: 'Detalle de Cita',
      buttonTitle: 'Ver historial de sesiones',
      text: '',
      display: {},
      valueLocal: null,
      noPhoto: 'https://developers.google.cn/web/images/contributors/no-photo.jpg?hl=es',
    };
  },
  watch: {
    value() {
      if (this.value !== this.valueLocal) {
        this.$el.children.namedItem('RTE__edition__field').innerHTML = this.value;
        this.valueLocal = this.value;
      }
    },
  },
  computed: {
    ...mapState({
      appointment: state => state.appointments.appointment,
      detailAppointment: state => state.specialist.appointments.detailAppointment,
      loading: state => state.specialist.appointments.loading,
    }),
    patientPhoto() {
      const photo = this.detailAppointment.appointment.patient.profileImageUrl;
      return photo || this.noPhoto;
    },
  },
  mounted() {
    this.getAppointmentDetails();
    this.valueLocal = this.value;

    this.display = {
      ...this.buttonsDisplay,
    };
  },
  methods: {
    ...mapActions({
      getAppointment: 'appointments/getAppointment',
      registerLinkInDetailAppointment: 'specialist/appointments/registerLinkInDetailAppointment',
      getAppointmentDetail: 'specialist/appointments/getAppointmentDetail',
      saveResults: 'appointments/saveResults',
      getAgoraName: 'videocall/videocalls/getAgoraName',
      registerDocumentInDetailAppointment: 'specialist/appointments/registerDocumentInDetailAppointment',
    }),
    joinVideocall() {
      this.getAgoraName(this.$route.params.id)
        .then((response) => {
          console.log(response);
          open(this.$config.ctVideocallingUrl + '/videocalling/' + response.data, '_blank');
        });
    },
    disabledAppointment(isCancelable, state) {
      if (!isCancelable || state === 1) {
        return true;
      }
      return false;
    },
    cancelAppointment() {
      this.forceRenderAlert();
      this.dialogAlert = true;
    },
    availabilityVideocalling(startTime, endTime, state) {
      const date = new Date();
      const dateString = date.getFullYear() + '-' + (((date.getMonth() + 1) < 10) ? '0' : '') + (date.getMonth() + 1) + '-' + ((date.getDate() < 10) ? '0' : '') + date.getDate() + 'T' + ((date.getHours() < 10) ? '0' : '') + date.getHours() + ':' + ((date.getMinutes() < 10) ? '0' : '') + date.getMinutes() + ':' + ((date.getSeconds() < 10) ? '0' : '') + date.getSeconds();
      const validateIni = startTime.valueOf() <= dateString.valueOf();
      const validateEnd = endTime.valueOf() > dateString.valueOf();
      const validateState = state !== 1;
      return validateIni && validateEnd && validateState;
    },
    getColorChip(stateSession) {
      if (stateSession === 0) {
        return 'orange  ';
      }
      if (stateSession === 1) {
        return 'red';
      }
      return 'primary';
    },
    getNameState(stateSession) {
      if (stateSession === 0) {
        return 'PENDIENTE';
      }
      if (stateSession === 1) {
        return 'CANCELADA';
      }
      return 'FINALIZADO';
    },
    goToLink(url) {
      window.open(url);
    },
    goToRecord(dni) {
      this.$router.push(`/especialista/pacientes/${dni}`);
    },
    formatDate(date) {
      if (!date) { return null; }

      const [year, month, day] = date.split('-');
      const weekDayName =  moment(date).locale('es').format('dddd');
      const capitalizewd = weekDayName[0].toUpperCase() + weekDayName.slice(1);
      const months = ['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto',
        'setiembre', 'octubre', 'noviembre', 'diciembre'];
      const [dayNumber, tail] = day.split('T');
      return `${capitalizewd} ${dayNumber} de ${months[month - 1]} del ${year}`;
    },
    formatHour(hourIni, hourFin) {
      const startHour = formatAMPM(new Date(hourIni))
      const endHour = formatAMPM(new Date(hourFin))
      return `De ${startHour} a ${endHour}`;
    },
    getAppointmentDetails() {
      this.getAppointmentDetail({ idAppointment: this.$route.params.id });
    },
    postLink({ nameLink, link }) {
      this.dialogAddLink = false;
      const payload = {
        name: nameLink,
        url: link,
      };
      this.registerLinkInDetailAppointment({ idAppointment: this.detailAppointment.idAppointmentDetail, payload })
        .then((response) => {
          this.getAppointmentDetails();
        });
    },
    openLink(link) {
      window.open(link, '_blank');
    },
    addDocumentInDetail() {
      this.forceRenderDocument();
      this.dialogAddDocument = true;
    },
    addLinkInDetail() {
      this.forceRenderLink();
      this.dialogAddLink = true;
    },
    forceRenderLink() {
      this.dialogLinkKey += 1;
    },
    forceRenderDocument() {
      this.dialogDocumentKey += 1;
    },
    forceRenderAlert() {
      this.dialogAlertKey += 1;
    },
    forceRenderDocumentShow() {
      this.renderDocuments += 1;
    },
    onUpdate(event) {
      this.valueLocal = event.target.innerHTML;
      console.log('ONUPDATE', event.target.innerHTML);
    },
    save() {
      this.saveResults({ sessionId: this.detailAppointment.idAppointmentDetail, results: this.valueLocal });
    },
    changeFontStyle() {
      this.fontWeight = this.toggle_multiple.includes(1) ? 'bold' : 'normal';
      this.fontStyle = this.toggle_multiple.includes(2) ? 'italic' : 'normal';
    },
    changeTextAlign() {
      if (this.toggle_exclusive === 2) {
        this.isLeft = false;
        this.isCentered = true;
        this.isRight = false;
        this.isJustify = false;
      } else {
        this.isLeft = true;
        this.isCentered = false;
        this.isRight = false;
        this.isJustify = false;
      }
    },
  },
};
</script>

<style scoped>
.centered-input >>> textarea {
  text-align: center
}
.left-input >>> textarea {
  text-align: left
}
.v-container-info-patient {
  display: flex;
  align-items: center;
}
#RTE__edition__field {
  border: 1px solid;
  padding: 5px;
  border-radius: 20px;
}
#RTE__edition__field2 {
  border: 1px solid;
  padding: 5px;
  border-radius: 20px;
}

.v-container-info-appointment {
  display: flex;
  align-items: center;
}
.button-start-session {
  padding-bottom: 20px;
}
.v-container-Patient-info {
  background: #F8F8F8;
}
</style>
